Index: code/branches/core7/src/libraries/core/CMakeLists.txt
===================================================================
--- code/branches/core7/src/libraries/core/CMakeLists.txt	(revision 10328)
+++ code/branches/core7/src/libraries/core/CMakeLists.txt	(revision 10342)
@@ -66,4 +66,5 @@
 ADD_SUBDIRECTORY(config)
 ADD_SUBDIRECTORY(input)
+ADD_SUBDIRECTORY(module)
 ADD_SUBDIRECTORY(object)
 
Index: code/branches/core7/src/libraries/core/Core.cc
===================================================================
--- code/branches/core7/src/libraries/core/Core.cc	(revision 10328)
+++ code/branches/core7/src/libraries/core/Core.cc	(revision 10342)
@@ -77,4 +77,5 @@
 #include "input/InputManager.h"
 #include "object/ObjectList.h"
+#include "module/ModuleInstance.h"
 
 namespace orxonox
@@ -139,4 +140,6 @@
         }
 
+        ModuleInstance::getCurrentModuleInstance()->loadAllStaticallyInitializedInstances();
+
         // Parse command line arguments AFTER the modules have been loaded (static code!)
         CommandLineParser::parse(cmdLine);
Index: code/branches/core7/src/libraries/core/CorePrereqs.h
===================================================================
--- code/branches/core7/src/libraries/core/CorePrereqs.h	(revision 10328)
+++ code/branches/core7/src/libraries/core/CorePrereqs.h	(revision 10342)
@@ -169,4 +169,5 @@
     class MemoryArchive;
     class MemoryArchiveFactory;
+    class ModuleInstance;
     class Namespace;
     class NamespaceNode;
@@ -187,4 +188,5 @@
     template <class T>
     class SmartPtr;
+    class StaticallyInitializedInstance;
     template <class T>
     class SubclassIdentifier;
Index: code/branches/core7/src/libraries/core/module/CMakeLists.txt
===================================================================
--- code/branches/core7/src/libraries/core/module/CMakeLists.txt	(revision 10342)
+++ code/branches/core7/src/libraries/core/module/CMakeLists.txt	(revision 10342)
@@ -0,0 +1,4 @@
+ADD_SOURCE_FILES(CORE_SRC_FILES
+  ModuleInstance.cc
+  StaticallyInitializedInstance.cc
+)
Index: code/branches/core7/src/libraries/core/module/ModuleInstance.cc
===================================================================
--- code/branches/core7/src/libraries/core/module/ModuleInstance.cc	(revision 10342)
+++ code/branches/core7/src/libraries/core/module/ModuleInstance.cc	(revision 10342)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "ModuleInstance.h"
+
+#include "StaticallyInitializedInstance.h"
+
+namespace orxonox
+{
+    ModuleInstance* ModuleInstance::currentModuleInstance_s = NULL;
+
+    void ModuleInstance::addStaticallyInitializedInstance(StaticallyInitializedInstance* instance)
+    {
+        this->staticallyInitializedInstances_.push_back(instance);
+    }
+
+    void ModuleInstance::loadAllStaticallyInitializedInstances()
+    {
+        for (size_t i = 0; i < this->staticallyInitializedInstances_.size(); ++i)
+            this->staticallyInitializedInstances_[i]->load();
+    }
+
+    /*static*/ void ModuleInstance::setCurrentModuleInstance(ModuleInstance* instance)
+    {
+        ModuleInstance::currentModuleInstance_s = instance;
+    }
+
+    /*static*/ ModuleInstance* ModuleInstance::getCurrentModuleInstance()
+    {
+        if (!ModuleInstance::currentModuleInstance_s)
+            ModuleInstance::currentModuleInstance_s = new ModuleInstance();
+        return ModuleInstance::currentModuleInstance_s;
+    }
+}
Index: code/branches/core7/src/libraries/core/module/ModuleInstance.h
===================================================================
--- code/branches/core7/src/libraries/core/module/ModuleInstance.h	(revision 10342)
+++ code/branches/core7/src/libraries/core/module/ModuleInstance.h	(revision 10342)
@@ -0,0 +1,54 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _ModuleInstance_H__
+#define _ModuleInstance_H__
+
+#include "core/CorePrereqs.h"
+
+#include <vector>
+
+namespace orxonox
+{
+    class _CoreExport ModuleInstance
+    {
+        public:
+            void addStaticallyInitializedInstance(StaticallyInitializedInstance* instance);
+            void loadAllStaticallyInitializedInstances();
+
+            static void setCurrentModuleInstance(ModuleInstance* instance);
+            static ModuleInstance* getCurrentModuleInstance();
+
+        private:
+            std::vector<StaticallyInitializedInstance*> staticallyInitializedInstances_;
+
+            static ModuleInstance* currentModuleInstance_s;
+    };
+}
+
+#endif /* _ModuleInstance_H__ */
Index: code/branches/core7/src/libraries/core/module/StaticallyInitializedInstance.cc
===================================================================
--- code/branches/core7/src/libraries/core/module/StaticallyInitializedInstance.cc	(revision 10342)
+++ code/branches/core7/src/libraries/core/module/StaticallyInitializedInstance.cc	(revision 10342)
@@ -0,0 +1,39 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "StaticallyInitializedInstance.h"
+
+#include "ModuleInstance.h"
+
+namespace orxonox
+{
+    StaticallyInitializedInstance::StaticallyInitializedInstance()
+    {
+        ModuleInstance::getCurrentModuleInstance()->addStaticallyInitializedInstance(this);
+    }
+}
Index: code/branches/core7/src/libraries/core/module/StaticallyInitializedInstance.h
===================================================================
--- code/branches/core7/src/libraries/core/module/StaticallyInitializedInstance.h	(revision 10342)
+++ code/branches/core7/src/libraries/core/module/StaticallyInitializedInstance.h	(revision 10342)
@@ -0,0 +1,46 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticallyInitializedInstance_H__
+#define _StaticallyInitializedInstance_H__
+
+#include "core/CorePrereqs.h"
+
+namespace orxonox
+{
+    class _CoreExport StaticallyInitializedInstance
+    {
+        public:
+            StaticallyInitializedInstance();
+            virtual ~StaticallyInitializedInstance() {}
+
+            virtual void load() = 0;
+    };
+}
+
+#endif /* _StaticallyInitializedInstance_H__ */