Index: /branches/camera/src/story_entities/game_world_data.cc
===================================================================
--- /branches/camera/src/story_entities/game_world_data.cc	(revision 10342)
+++ /branches/camera/src/story_entities/game_world_data.cc	(revision 10343)
@@ -102,5 +102,5 @@
     localCamera->setName ("GameWorld-Camera");
   State::setCamera(localCamera, localCamera->getTarget());
-  cameraman* camMan = new cameraman();
+  CameraMan* camMan = new CameraMan();
   State::setCameraman(camMan);
   LightManager::getInstance();
@@ -334,5 +334,5 @@
   LoadParamXML(root, "GameRule", this, GameWorldData, loadGameRule);
 
-  LoadParam(root, "clip-region", State::getCameraman(), cameraman, setClipRegion);
+  LoadParam(root, "clip-region", State::getCameraman(), CameraMan, setClipRegion);
 
 
Index: /branches/camera/src/util/state.cc
===================================================================
--- /branches/camera/src/util/state.cc	(revision 10342)
+++ /branches/camera/src/util/state.cc	(revision 10343)
@@ -33,5 +33,5 @@
 CameraTarget* State::cameraTarget = NULL;
 
-cameraman* State::CameraMan = NULL;
+CameraMan* State::cameraManager = NULL;
 
 PNode* State::cameraNode = NULL;
@@ -68,7 +68,7 @@
 
 
-void State::setCameraman(cameraman* cm)
+void State::setCameraman(CameraMan* cm)
 
 {
-  State::CameraMan=cm;
+  State::cameraManager=cm;
 }
Index: /branches/camera/src/util/state.h
===================================================================
--- /branches/camera/src/util/state.h	(revision 10342)
+++ /branches/camera/src/util/state.h	(revision 10343)
@@ -18,5 +18,5 @@
 class ObjectManager;
 class GameRules;
-class cameraman;
+class CameraMan;
 class ScriptManager;
 
@@ -48,7 +48,7 @@
   /// CAMERAMANAGER ///
   /////////////////////
-  /** @param cameraman the PNode to the CameraManager,*/
-  static void setCameraman(cameraman*);
-  static inline cameraman* getCameraman() { return State::CameraMan; };
+  /** @param CameraMan the PNode to the cameraManagerager,*/
+  static void setCameraman(CameraMan*);
+  static inline CameraMan* getCameraman() { return State::cameraManager; };
 
 
@@ -126,5 +126,5 @@
   static Camera*                camera;             //!< The current Camera.
   static CameraTarget*          cameraTarget;       //!< The Camera Target.
-  static cameraman*             CameraMan;
+  static CameraMan*             cameraManager;
   static PNode*                 cameraNode;         //!< A reference to the camera
   static PNode*                 cameraTargetNode;   //!< A reference to the cameraTarget
Index: /branches/camera/src/world_entities/blackscreen.cc
===================================================================
--- /branches/camera/src/world_entities/blackscreen.cc	(revision 10342)
+++ /branches/camera/src/world_entities/blackscreen.cc	(revision 10343)
@@ -89,4 +89,7 @@
 }
 
+
+
+
 void BlackScreen::draw() const
 {
@@ -100,12 +103,8 @@
 
   glBegin(GL_QUADS);
-  glVertex3f(State::getCameraNode()->getAbsCoorX()+3,State::getCameraNode()->getAbsCoorY() -100.0f,
-             State::getCameraNode()->getAbsCoorZ()-100.0f);
-  glVertex3f(State::getCameraNode()->getAbsCoorX()+3, State::getCameraNode()->getAbsCoorY()-100.0f,
-             State::getCameraNode()->getAbsCoorZ()+100.0f);
-  glVertex3f(State::getCameraNode()->getAbsCoorX()+3, State::getCameraNode()->getAbsCoorY() +100.0f,
-             State::getCameraNode()->getAbsCoorZ()+100.0f);
-  glVertex3f(State::getCameraNode()->getAbsCoorX()+3, State::getCameraNode()->getAbsCoorY()+100.0f,
-             State::getCameraNode()->getAbsCoorZ()-100.0f);
+  glVertex3f(0.,-100.0f,-100.0f);
+  glVertex3f(0., -100.0f,100.0f);
+  glVertex3f(0., 100.0f,100.0f);
+  glVertex3f(0., 100.0f,-100.0f);
 
   glEnd();
Index: /branches/camera/src/world_entities/cameraman.cc
===================================================================
--- /branches/camera/src/world_entities/cameraman.cc	(revision 10342)
+++ /branches/camera/src/world_entities/cameraman.cc	(revision 10343)
@@ -18,14 +18,13 @@
 #include "game_world_data.h"
 #include "state.h"
-#include "iostream.h"
 #include "sound_engine.h"
 #include <string>
 
-ObjectListDefinition(cameraman);
+ObjectListDefinition(CameraMan);
 
 
-cameraman::cameraman()
+CameraMan::CameraMan()
 {
-  this->registerObject(this, cameraman::_objectList);
+  this->registerObject(this, CameraMan::_objectList);
 
   this->nearClip = 1.0;
@@ -39,5 +38,5 @@
 
 
-void cameraman::createCam()
+void CameraMan::createCam()
 {
  // Camera* newCamera=new Camera();
@@ -48,5 +47,5 @@
 }
 
-void cameraman::setCam(int cameraNo)
+void CameraMan::setCam(int cameraNo)
 {
   if (cameraNo<cameras.size())
@@ -55,5 +54,6 @@
   State::setCamera(currentCam, currentCam->getTarget());
   OrxSound::SoundEngine::getInstance()->setListener(currentCam);
-
+  this->fadeToBlack->setParent(this->currentCam);
+  this->fadeToBlack->setRelCoor(3., 0., 0.);
   }
 
@@ -61,5 +61,5 @@
 
 
-void cameraman::testCam()
+void CameraMan::testCam()
 {
 cameras[1]->lookAt(currentCam->getTarget());
@@ -68,5 +68,5 @@
 
 
-void cameraman::moveCurrCam(int x, int y, int z)
+void CameraMan::moveCurrCam(int x, int y, int z)
 {
 currentCam->target->trans(x,y,z);
@@ -74,5 +74,5 @@
 
 
-void cameraman::moveCam(int x, int y, int z, int camNo)
+void CameraMan::moveCam(int x, int y, int z, int camNo)
 {
 cameras[camNo]->target->trans(x,y,z);
@@ -80,5 +80,5 @@
 
 
-void cameraman::changeTarget(int camNo, std::string className, std::string objectName)
+void CameraMan::changeTarget(int camNo, std::string className, std::string objectName)
 {
   BaseObject* object = ObjectListBase::getBaseObject(className, objectName);
@@ -88,5 +88,5 @@
 
 
-void cameraman::changeCurrTarget(std::string className, std::string objectName)
+void CameraMan::changeCurrTarget(std::string className, std::string objectName)
 {
   BaseObject* object = ObjectListBase::getBaseObject(className, objectName);
@@ -95,10 +95,10 @@
 }
 
-void cameraman::atachCurrTarget(PNode* target)
+void CameraMan::atachCurrTarget(PNode* target)
 {
   currentCam->target->atach(target);
 }
 
-void cameraman::jumpCam(int x, int y, int z, int camNo)
+void CameraMan::jumpCam(int x, int y, int z, int camNo)
 {
   cameras[camNo]->target->jump(x, y, z);
@@ -107,5 +107,5 @@
 
 
-void cameraman::setClipRegion(float nearCli, float farCli)
+void CameraMan::setClipRegion(float nearCli, float farCli)
 {
   this->nearClip=nearCli;
@@ -117,5 +117,5 @@
 
 
-void cameraman::jumpCurrCam(int x, int y, int z)
+void CameraMan::jumpCurrCam(int x, int y, int z)
 {
   currentCam->target->jump(x, y, z);
@@ -125,5 +125,5 @@
 
 
-void cameraman::togglFade()
+void CameraMan::togglFade()
 {
   if( this->fadeToBlack)
Index: /branches/camera/src/world_entities/cameraman.h
===================================================================
--- /branches/camera/src/world_entities/cameraman.h	(revision 10342)
+++ /branches/camera/src/world_entities/cameraman.h	(revision 10343)
@@ -8,6 +8,6 @@
 #include "blackscreen.h"
 
-class cameraman : public BaseObject {
-  ObjectListDeclaration(cameraman);
+class CameraMan : public BaseObject {
+  ObjectListDeclaration(CameraMan);
 
   private:
@@ -19,5 +19,5 @@
   public:
     std::vector<Camera*> cameras;
-    cameraman();
+    CameraMan();
     void setCam(int CameraNo);
     void createCam();
Index: /branches/camera/src/world_entities/test_entity.h
===================================================================
--- /branches/camera/src/world_entities/test_entity.h	(revision 10342)
+++ /branches/camera/src/world_entities/test_entity.h	(revision 10343)
@@ -14,5 +14,5 @@
   private:
 
-  cameraman* CM;
+  CameraMan* CM;
 
   public: