Index: code/branches/core7/src/orxonox/Scene.cc
===================================================================
--- code/branches/core7/src/orxonox/Scene.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/Scene.cc	(revision 10347)
@@ -44,5 +44,5 @@
 #include "core/GUIManager.h"
 #include "core/XMLPort.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "tools/BulletConversions.h"
 #include "tools/BulletDebugDrawer.h"
Index: code/branches/core7/src/orxonox/Test.cc
===================================================================
--- code/branches/core7/src/orxonox/Test.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/Test.cc	(revision 10347)
@@ -29,5 +29,5 @@
 #include "core/CoreIncludes.h"
 #include "core/config/ConfigValueIncludes.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "network/NetworkFunction.h"
 #include "Test.h"
Index: code/branches/core7/src/orxonox/chat/ChatInputHandler.cc
===================================================================
--- code/branches/core7/src/orxonox/chat/ChatInputHandler.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/chat/ChatInputHandler.cc	(revision 10347)
@@ -50,5 +50,5 @@
 #include "core/CoreIncludes.h"
 #include "core/GUIManager.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "core/input/InputBuffer.h"
 #include "core/input/InputManager.h"
Index: code/branches/core7/src/orxonox/chat/ChatManager.cc
===================================================================
--- code/branches/core7/src/orxonox/chat/ChatManager.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/chat/ChatManager.cc	(revision 10347)
@@ -32,5 +32,5 @@
 #include "util/ScopedSingletonManager.h"
 #include "core/CoreIncludes.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "network/Host.h"
 
Index: code/branches/core7/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/branches/core7/src/orxonox/controllers/ArtificialController.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/controllers/ArtificialController.cc	(revision 10347)
@@ -30,5 +30,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "worldentities/pawns/Pawn.h"
 #include "worldentities/pawns/SpaceShip.h"
Index: code/branches/core7/src/orxonox/controllers/FormationController.cc
===================================================================
--- code/branches/core7/src/orxonox/controllers/FormationController.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/controllers/FormationController.cc	(revision 10347)
@@ -33,5 +33,5 @@
 
 #include "core/XMLPort.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 
 #include "worldentities/ControllableEntity.h"
Index: code/branches/core7/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/branches/core7/src/orxonox/controllers/HumanController.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/controllers/HumanController.cc	(revision 10347)
@@ -30,5 +30,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "worldentities/ControllableEntity.h"
 #include "worldentities/pawns/Pawn.h"
Index: code/branches/core7/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/branches/core7/src/orxonox/controllers/NewHumanController.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/controllers/NewHumanController.cc	(revision 10347)
@@ -37,5 +37,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "core/input/KeyBinder.h"
 #include "core/input/KeyBinderManager.h"
Index: code/branches/core7/src/orxonox/gamestates/GSLevel.cc
===================================================================
--- code/branches/core7/src/orxonox/gamestates/GSLevel.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/gamestates/GSLevel.cc	(revision 10347)
@@ -44,5 +44,5 @@
 #include "core/Loader.h"
 #include "core/XMLFile.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 
 #include "LevelManager.h"
Index: code/branches/core7/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/branches/core7/src/orxonox/gamestates/GSMainMenu.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/gamestates/GSMainMenu.cc	(revision 10347)
@@ -36,5 +36,5 @@
 #include "core/GraphicsManager.h"
 #include "core/GUIManager.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "core/input/KeyBinderManager.h"
 #include "network/Client.h"
Index: code/branches/core7/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- code/branches/core7/src/orxonox/gamestates/GSRoot.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/gamestates/GSRoot.cc	(revision 10347)
@@ -33,5 +33,5 @@
 #include "core/Game.h"
 #include "core/GameMode.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "network/NetworkFunction.h"
 #include "tools/Timer.h"
Index: code/branches/core7/src/orxonox/gametypes/Gametype.cc
===================================================================
--- code/branches/core7/src/orxonox/gametypes/Gametype.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/gametypes/Gametype.cc	(revision 10347)
@@ -34,5 +34,5 @@
 #include "core/config/ConfigValueIncludes.h"
 #include "core/GameMode.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "gamestates/GSLevel.h"
 
Index: code/branches/core7/src/orxonox/gametypes/Mission.cc
===================================================================
--- code/branches/core7/src/orxonox/gametypes/Mission.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/gametypes/Mission.cc	(revision 10347)
@@ -33,5 +33,5 @@
 
 #include "core/CoreIncludes.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "infos/PlayerInfo.h"
 #include "network/Host.h"
Index: code/branches/core7/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/branches/core7/src/orxonox/overlays/InGameConsole.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/overlays/InGameConsole.cc	(revision 10347)
@@ -50,5 +50,5 @@
 #include "core/CoreIncludes.h"
 #include "core/config/ConfigValueIncludes.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "core/GUIManager.h"
 #include "core/input/InputManager.h"
Index: code/branches/core7/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/branches/core7/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 10347)
@@ -48,5 +48,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 
 #include "OverlayGroup.h"
Index: code/branches/core7/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- code/branches/core7/src/orxonox/overlays/OverlayGroup.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/overlays/OverlayGroup.cc	(revision 10347)
@@ -36,5 +36,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include "OrxonoxOverlay.h"
 
Index: code/branches/core7/src/orxonox/sound/WorldAmbientSound.cc
===================================================================
--- code/branches/core7/src/orxonox/sound/WorldAmbientSound.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/sound/WorldAmbientSound.cc	(revision 10347)
@@ -33,5 +33,5 @@
 #include "core/XMLPort.h"
 #include "AmbientSound.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 #include <exception>
 
Index: code/branches/core7/src/orxonox/worldentities/pawns/ModularSpaceShip.cc
===================================================================
--- code/branches/core7/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/worldentities/pawns/ModularSpaceShip.cc	(revision 10347)
@@ -37,5 +37,5 @@
 #include "util/Math.h"
 #include "gametypes/Gametype.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 
 #include "items/ShipPart.h"
Index: code/branches/core7/src/orxonox/worldentities/pawns/Spectator.cc
===================================================================
--- code/branches/core7/src/orxonox/worldentities/pawns/Spectator.cc	(revision 10345)
+++ code/branches/core7/src/orxonox/worldentities/pawns/Spectator.cc	(revision 10347)
@@ -34,5 +34,5 @@
 #include "core/GameMode.h"
 #include "core/command/CommandExecutor.h"
-#include "core/command/ConsoleCommand.h"
+#include "core/command/ConsoleCommandIncludes.h"
 
 #include "tools/BillboardSet.h"